#ifndef CARD_H
#define CARD_H

#include <qstring.h>

#include <iosfwd>
#include <vector>

namespace pitacard { namespace data {

    using namespace std;
    
    class Card
    {
    public:
	struct Face
	{
	    Face();
	    Face(const QString& text);
	    
	    QString mText;
	    // TODO: KeyTranslator name goes here...in the future
	};

    public:
	Card();
	Card(const QString& name);
	Card(const QString& name,
	     const QString& frontText,
	     const QString& backText);

	void setName(const QString& name);
	void setFront(const Face& f);
	void setBack(const Face& f);

	const QString& name() const;
	Face& front();
	const Face& front() const;
	Face& back();
	const Face& back() const;

    private:
	Face mFront;
	Face mBack;
	QString mName;
    };

    bool operator==(const Card::Face& lhs, const Card::Face& rhs);
    bool operator==(const Card& lhs, const Card& rhs);

    std::ostream& operator<<(std::ostream& os, const Card::Face& f);
    std::ostream& operator<<(std::ostream& os, const Card& c);
    
} }

#endif
