#include "deckwriter.h"

#include "folder.h"

#include <iostream>

#include <qdatastream.h>
#include <qfile.h>
#include <qstring.h>

using namespace pitacard::data;

namespace
{

    static unsigned int formatVersion = 2;

    void writeDeck_impl(QDataStream& ds, const Folder& deck)
    {
	ds << deck.mName;
	
	ds << deck.mCards.size();
	for (Folder::Cards::const_iterator itr = deck.mCards.begin();
	     itr != deck.mCards.end();
	     ++itr)
	{
	    ds << itr->name()
	       << itr->front().mText
	       << itr->back().mText;
	}

	ds << deck.mFolders.size();
	for (Folder::Folders::const_iterator itr = deck.mFolders.begin();
	     itr != deck.mFolders.end();
	     ++itr)
	{
	    writeDeck_impl(ds, *itr);
	}
    }
    
}

namespace pitacard { namespace io {

    void writeDeck(QDataStream& ds, const Folder& deck)
    {
	ds << formatVersion;
	
	writeDeck_impl(ds, deck);
    }
    
    void writeDeck(const QString& filename, const pitacard::data::Folder& deck)
    {
	QFile infile(filename);
	infile.open(IO_WriteOnly);
	QDataStream ds(&infile);
	writeDeck(ds, deck);
    } 
    
} }
