#include "keyTranslator.h"

#include <qstring.h>

namespace pitacard { namespace xlat {

    void KeyTranslator::insert(Key key, State state, const QString& u)
    {
	mKeyMap[std::make_pair(key, state)] = u;
    }
    
    void KeyTranslator::remove(Key key, State state)
    {
	mKeyMap.erase(std::make_pair(key, state));
    }
    
    QString KeyTranslator::operator()(Key key, State state) const
    {
	KeyMap::const_iterator itr = mKeyMap.find(std::make_pair(key, state));
	if (itr == mKeyMap.end())
	    throw QString("[KeyTranslator::operator()] No translation available");

	return itr->second;
    }
    
} }
