#ifndef KEYTRANSLATOR_H
#define KEYTRANSLATOR_H

#include <map>
#include <utility>

#include <qstring.h>

namespace pitacard { namespace xlat {

    class KeyTranslator
    {
    public:
	typedef int Key;
	typedef int State;

	void insert(Key key, State state, const QString& sz);
	void remove(Key key, State state);

	QString operator()(Key key, State state) const;
	
    private:
	typedef std::map<std::pair<Key, State>, QString> KeyMap;
	KeyMap mKeyMap;
    };
    
} }

#endif
