/*
pitacard: A flash card program
Copyright (C) 2003 Austin Bingham

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You can reach the author at:
    abingham@spamcop.net
*/

#include "DeckEditorUI.h"
#include "globals.h"

#include <qapplication.h>

#include <iostream>
#include <stdexcept>

int main(int argc, char** argv)
{
    using namespace std;

    pitacard::config::initializeConfiguration();
    
#if 0
    // process command line
    while (true)
    {
	int c = getopt_long (argc, argv, "d:o:",
			     NULL, NULL);

	if (c == -1) break;

	switch (c)
        {
	    case 'd':
		gpsmgr::io::gps::setDevice(optarg);
		break;

	    case 'o':
		// enableDebugChannel(optarg, true);
		break;
	}
    }
#endif

    // Fire up the GUI
    try
    {
	using namespace pitacard::ui;
	
	QApplication app(argc,argv);
	DeckEditorUI deu;
	app.setMainWidget(&deu);
	deu.show();
	int rval = app.exec();
	pitacard::config::saveConfiguration();
	return rval;
    }
    catch (runtime_error& exc)
    {
	cerr << "EXCEPTION (runtime_error): " << exc.what() << endl;
	return 2;
    }
    catch (exception& e)
    {
	cerr << "EXCEPTION" << endl;
	return 3;
    }

    return 0;
}
