#include "xlatTextEdit.h"

#include <qstring.h>

#include <iostream>

using namespace std;

namespace pitacard { namespace ui {

    using namespace pitacard::xlat;
    
    XlatTextEdit::XlatTextEdit(const QString& text,
			       const QString& context,
			       QWidget* parent,
			       const char* name) :
	QTextEdit (text, context, parent, name)
    {}
    
    XlatTextEdit::XlatTextEdit(QWidget* parent,
			       const char* name) :
	QTextEdit (parent, name)
    {}

    void XlatTextEdit::setKeyTranslator(const KeyTranslator& kt)
    {
	mXlat = kt;
    }
    
    void XlatTextEdit::keyPressEvent(QKeyEvent* e)
    {
	try
	{
	    QString sz = mXlat(e->key(), e->state());
	    e->accept();

	    // We have to pretty much spoof the entire key event because
	    // otherwise the TextEdit base class keys off of entries in it.
	    QKeyEvent ke(QEvent::KeyPress,
			 Qt::Key_A,
			 0x61,
			 Qt::NoButton,
			 sz);
	    QTextEdit::keyPressEvent(&ke);
	}
	catch (QString& exc)
	{
	    QTextEdit::keyPressEvent(e);
	}
    }

    void XlatTextEdit::focusInEvent(QFocusEvent* e)
    { grabKeyboard(); }
    
    void XlatTextEdit::focusOutEvent(QFocusEvent* e)
    { releaseKeyboard(); }
    
} }
